from microbit import *
#import os
import radio
#Newspeedslave4
starttime = 0
card = 0.1
threshold = 800

AVAL = 1500
RSET = 9000

HI = Image("99999:00000:00000:00000:00000")
LO = Image("00000:00000:00000:00000:99999")
HIB = Image("00099:09000:99000:09000:00000")
LOB = Image("00000:09000:99000:09000:00099")

#main loop
while True:

    if button_a.is_pressed():

        break

    display.show("4")
#setup lightgate option btn a to exit
sleep(700)
while True:
    llvl = pin1.read_analog()
    if button_a.is_pressed():
        break
    elif llvl > threshold: display.show(HIB)
    else: display.show(LOB)
    #print(llvl)
while True:
    #prompt the user to press the left btn (a)to start
    #display.show(Image.ARROW_W)
    radio.on()
    #wait for button a to be pressed
    #while True:
        #if button_a.is_pressed():
            #break


    display.show(Image.YES)
    #wait for radio start signal (1000)
    while True:
        incoming = radio.receive()
        if incoming == '1000':
            break
    tstamp1 = running_time()
    #wait for radio stop signal (2000)
    while True:
        incoming = radio.receive()
        if incoming == '2000':
            break
    tstamp2 = running_time()
    #wait for light level drop HI to LO       
    while True:
        if pin1.read_analog() > threshold :
            display.show(HI)
            break
    while True:
        if pin1.read_analog() <= threshold:
            display.show(LO)
            break

    tstamp3 = running_time()

    #wait for light level rise LO to HI       

    while True:
        if pin1.read_analog() < threshold :
            display.show(LO)
            break
    while True:
        if pin1.read_analog() >= threshold:
            display.show(HI)
            break

    tstamp4 = running_time()

    beam_time = (tstamp4 - tstamp3) / 1000

    gap_time = ((tstamp2 - tstamp1)/2000 ) + ((tstamp3 - tstamp2) / 1000) + (beam_time/2)
    gap_time = round(gap_time, 3)
    speed = (card / beam_time)

    speed = round(speed, 3)
    j_time = tstamp3 -tstamp1

    display.scroll("gap time= "+str(gap_time)+"s"+" speed= "+str(speed)+"m/s", wait=False, loop=True)


    while True:
        incoming = radio.receive()
        if incoming == '9000':

            display.clear()
            break
        #display.scroll("gap time= "+str(gap_time)+"ms")

        #display.scroll("speed= "+str(speed)+"cm/s")          

        #display.scroll("journey= "+str(j_time)+"ms")
    sleep(500)

